diff --git a/src/sapB_fmt_plug.c b/src/sapB_fmt_plug.c
index b2d099c7fd..9161ed9bda 100644
--- a/src/sapB_fmt_plug.c
+++ b/src/sapB_fmt_plug.c
@@ -485,7 +485,7 @@ static unsigned int walld0rf_magic(const int index, const unsigned char *temp_ke
 #if SIMD_COEF_32
 	// This may be unaligned here, but after the aligned vector buffer
 	// transfer, we will have no junk left from loop overrun
-	*(unsigned int*)&destArray[sum20] = 0x00000080;
+	memcpy(&destArray[sum20], "\x80\0\0\0", 4);	// this might be a source of BE alignment problems.
 #endif
 	return sum20;
 }
diff --git a/src/sapG_fmt_plug.c b/src/sapG_fmt_plug.c
index acdc73082b..328fcef21d 100644
--- a/src/sapG_fmt_plug.c
+++ b/src/sapG_fmt_plug.c
@@ -562,8 +562,14 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 			while (++i & 3)
 				saved_key[i>>6][GETPOS(i, ti)] = *p++;
 			// ...then a word at a time. This is a good boost, we are copying between 32 and 82 bytes here.
+#if ARCH_ALLOWS_UNALIGNED
 			for (;i < lengthIntoMagicArray + len; i += 4, p += 4)
 				*(uint32_t*)&saved_key[i>>6][GETWORDPOS(i, ti)] = JOHNSWAP(*(uint32_t*)p);
+#else
+			for (;i < lengthIntoMagicArray + len; ++i, ++p) {
+				saved_key[i>>6][GETPOS(i, ti)] = *p;
+			}
+#endif
 
 			// Now, the salt. This is typically too short for the stunt above.
 			for (i = 0; i < cur_salt->l; i++)
diff --git a/src/sapH_fmt_plug.c b/src/sapH_fmt_plug.c
index 386e87d8cd..0bfc8236f9 100644
--- a/src/sapH_fmt_plug.c
+++ b/src/sapH_fmt_plug.c
@@ -326,7 +326,13 @@ static void crypt_all_1(int count) {
 				uint32_t *pcrypt = &crypt32[ ((k/SIMD_COEF_32)*(SIMD_COEF_32*5)) + (k&(SIMD_COEF_32-1))];
 				uint32_t *Icp32 = (uint32_t *)(&keys[(k<<6)+offs[k]]);
 				for (j = 0; j < 5; ++j) {
+					// likely location for BE porting
+#if ARCH_ALLOWS_UNALIGNED
 					Icp32[j] = JOHNSWAP(*pcrypt);
+#else
+					uint32_t tmp = JOHNSWAP(*pcrypt);
+					memcpy(&Icp32[j], &tmp, 4);
+#endif
 					pcrypt += SIMD_COEF_32;
 				}
 			}
@@ -398,7 +404,12 @@ static void crypt_all_256(int count) {
 				uint32_t *pcrypt = &crypt32[ ((k/SIMD_COEF_32)*(SIMD_COEF_32*8)) + (k&(SIMD_COEF_32-1))];
 				uint32_t *Icp32 = (uint32_t *)(&keys[(k<<6)+offs[k]]);
 				for (j = 0; j < 8; ++j) {
+#if ARCH_ALLOWS_UNALIGNED
 					Icp32[j] = JOHNSWAP(*pcrypt);
+#else
+					uint32_t tmp = JOHNSWAP(*pcrypt);
+					memcpy(&Icp32[j], &tmp, 4);
+#endif
 					pcrypt += SIMD_COEF_32;
 				}
 			}
@@ -409,7 +420,12 @@ static void crypt_all_256(int count) {
 			uint32_t *Iptr32 = &crypt32[ ((i/SIMD_COEF_32)*(SIMD_COEF_32*8)) + (i&(SIMD_COEF_32-1))];
 			// we only want 16 bytes, not 32
 			for (j = 0; j < 4; ++j) {
+#if ARCH_ALLOWS_UNALIGNED
 				Optr32[j] = JOHNSWAP(*Iptr32);
+#else
+				uint32_t tmp = JOHNSWAP(*Iptr32);
+				memcpy(&Optr32[j], &tmp, 4);
+#endif
 				Iptr32 += SIMD_COEF_32;
 			}
 		}
@@ -471,7 +487,12 @@ static void crypt_all_384(int count) {
 				uint64_t *pcrypt = &crypt64[ ((k/SIMD_COEF_64)*(SIMD_COEF_64*8)) + (k&(SIMD_COEF_64-1))];
 				uint64_t *Icp64 = (uint64_t *)(&keys[(k<<7)+offs[k]]);
 				for (j = 0; j < 6; ++j) {
+#if ARCH_ALLOWS_UNALIGNED
 					Icp64[j] = JOHNSWAP64(*pcrypt);
+#else
+					uint64_t tmp = JOHNSWAP64(*pcrypt);
+					memcpy(&Icp64[j], &tmp, 8);
+#endif
 					pcrypt += SIMD_COEF_64;
 				}
 			}
@@ -543,7 +564,12 @@ static void crypt_all_512(int count) {
 				uint64_t *pcrypt = &crypt64[ ((k/SIMD_COEF_64)*(SIMD_COEF_64*8)) + (k&(SIMD_COEF_64-1))];
 				uint64_t *Icp64 = (uint64_t *)(&keys[(k<<7)+offs[k]]);
 				for (j = 0; j < 8; ++j) {
+#if ARCH_ALLOWS_UNALIGNED
 					Icp64[j] = JOHNSWAP64(*pcrypt);
+#else
+					uint64_t tmp = JOHNSWAP64(*pcrypt);
+					memcpy(&Icp64[j], &tmp, 8);
+#endif
 					pcrypt += SIMD_COEF_64;
 				}
 			}
